Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.cfg	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.cfg	(revision 429)
@@ -0,0 +1,33 @@
+/*
+ *		タイマドライバのコンフィギュレーションファイル（MPCore内蔵タイマ用）
+ *
+ *  $Id$
+ */
+
+/*
+ *  高分解能タイマドライバ
+ */
+#if defined(USE_MPCORE_TMRWDG_HRT) || defined(USE_MPCORE_GTC_HRT)
+
+ATT_INI({ TA_NULL, 0, _kernel_target_hrt_initialize });
+ATT_TER({ TA_NULL, 0, _kernel_target_hrt_terminate });
+
+CFG_INT(INTNO_TIMER, { TA_ENAINT|INTATR_TIMER, INTPRI_TIMER });
+DEF_INH(INHNO_TIMER, { TA_NULL, _kernel_target_hrt_handler });
+
+#endif /* defined(USE_MPCORE_TMRWDG_HRT) || defined(USE_MPCORE_GTC_HRT) */
+
+/*
+ *  オーバランタイマドライバ
+ */
+#ifdef USE_MPCORE_WDG_OVRTIMER
+#ifdef TOPPERS_SUPPORT_OVRHDR
+
+ATT_INI({ TA_NULL, 0, _kernel_target_ovrtimer_initialize });
+ATT_TER({ TA_NULL, 0, _kernel_target_ovrtimer_terminate });
+
+CFG_INT(INTNO_OVRTIMER, { TA_ENAINT|INTATR_OVRTIMER, INTPRI_OVRTIMER });
+DEF_INH(INHNO_OVRTIMER, { TA_NULL, _kernel_target_ovrtimer_handler });
+
+#endif /* TOPPERS_SUPPORT_OVRHDR */
+#endif /* USE_MPCORE_WDG_OVRTIMER */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.h	(revision 429)
@@ -0,0 +1,422 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
+ *                              Toyohashi Univ. of Technology, JAPAN
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		タイマドライバ（MPCore内蔵タイマ用）
+ *
+ *  MPCoreは，プロセッサ毎にプライベートタイマとウォッチドッグを持つ．
+ *  ウォッチドッグは，タイマとして使用することができる．また，各プロセッ
+ *  サからアクセスできるグローバルタイマを持つ．このモジュールは，対応
+ *  するシンボルをマクロ定義することにより，以下の機能を提供する．
+ *
+ *  USE_MPCORE_TMRWDG_HRT：
+ *		プライベートタイマとウォッチドッグを用いて，高分解能タイマを実
+ *		現する．具体的には，ウォッチドッグをタイマモードに設定して現在
+ *		時刻の管理のために用い，プライベートタイマを相対時間割込みの発
+ *		生のために用いる．
+ *
+ *  USE_MPCORE_GTC_HRT：
+ *		グローバルタイマを用いて，高分解能タイマを実現する．グローバル
+ *		タイマは，Cortex-A9 MPCoreのr2p0以降の新しい仕様のものを想定し
+ *		ている．
+ *
+ *  USE_MPCORE_WDG_OVRTIMER：
+ *		ウォッチドッグを用いて，オーバランタイマを実現する．
+ */
+
+#ifndef TOPPERS_MPCORE_TIMER_H
+#define TOPPERS_MPCORE_TIMER_H
+
+#include "kernel/kernel_impl.h"
+#include <sil.h>
+#include "mpcore.h"
+
+#ifdef USE_MPCORE_TMRWDG_HRT
+/*
+ *		プライベートタイマとウォッチドッグを用いて高分解能タイマを実現
+ */
+
+/*
+ *  タイマ割込みハンドラ登録のための定数
+ */
+#define INHNO_TIMER		MPCORE_IRQNO_TMR	/* 割込みハンドラ番号 */
+#define INTNO_TIMER		MPCORE_IRQNO_TMR	/* 割込み番号 */
+#define INTPRI_TIMER	(TMAX_INTPRI - 1)	/* 割込み優先度 */
+#define INTATR_TIMER	TA_NULL				/* 割込み属性 */
+
+/*
+ *  タイマの設定値のデフォルト値の定義
+ */
+#ifndef MPCORE_WDG_LR_VALUE
+#define MPCORE_WDG_LR_VALUE		0xffffffffU	/* ウォッチドッグのリロード値 */
+#endif /* MPCORE_WDG_LR_VALUE */
+
+#ifndef MPCORE_WDG_FREQ
+#define MPCORE_WDG_FREQ			1		/* ウォッチドッグの駆動周波数 */
+#endif /* MPCORE_WDG_FREQ */
+
+#ifndef MPCORE_TMR_FREQ
+#define MPCORE_TMR_FREQ			1		/* プライベートタイマの駆動周波数 */
+#endif /* MPCORE_TMR_FREQ */
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  高分解能タイマの起動処理
+ */
+extern void	target_hrt_initialize(intptr_t exinf);
+
+/*
+ *  高分解能タイマの停止処理
+ */
+extern void	target_hrt_terminate(intptr_t exinf);
+
+/*
+ *  高分解能タイマの現在のカウント値の読出し
+ */
+Inline HRTCNT
+target_hrt_get_current(void)
+{
+	/*
+	 *  ウォッチドッグのカウント値を読み出し，ダウンカウンタであるため，
+	 *  MPCORE_WDG_LR_VALUEから引き，MPCORE_WDG_FREQで除した値を返す．
+	 */
+	return((HRTCNT)((MPCORE_WDG_LR_VALUE - sil_rew_mem(MPCORE_WDG_CNT))
+														/ MPCORE_WDG_FREQ));
+}
+
+/*
+ *  高分解能タイマへの割込みタイミングの設定
+ *
+ *  高分解能タイマを，hrtcntで指定した値カウントアップしたら割込みを発
+ *  生させるように設定する．
+ */
+Inline void
+target_hrt_set_event(HRTCNT hrtcnt)
+{
+	/*
+	 *  タイマのカウント値を(hrtcnt * MPCORE_TMR_FREQ)に設定する．
+	 */
+	sil_wrw_mem(MPCORE_TMR_CNT, hrtcnt * MPCORE_TMR_FREQ);
+}
+
+/*
+ *  高分解能タイマ割込みの要求
+ */
+Inline void
+target_hrt_raise_event(void)
+{
+	raise_int(INTNO_TIMER);
+}
+
+/*
+ *  割込みタイミングに指定する最大値
+ */
+#if !defined(TCYC_HRTCNT) || (TCYC_HRTCNT > 4002000002U)
+#define HRTCNT_BOUND		4000000002U
+#else
+#define HRTCNT_BOUND		(TCYC_HRTCNT - 2000000U)
+#endif
+
+/*
+ *  高分解能タイマ割込みハンドラ
+ */
+extern void	target_hrt_handler(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* USE_MPCORE_TMRWDG_HRT */
+
+#ifdef USE_MPCORE_GTC_HRT
+/*
+ *		グローバルタイマを用いて高分解能タイマを実現
+ */
+
+/*
+ *  タイマ割込みハンドラ登録のための定数
+ */
+#define INHNO_TIMER		MPCORE_IRQNO_GTC	/* 割込みハンドラ番号 */
+#define INTNO_TIMER		MPCORE_IRQNO_GTC	/* 割込み番号 */
+#define INTPRI_TIMER	(TMAX_INTPRI - 1)	/* 割込み優先度 */
+#define INTATR_TIMER	TA_NULL				/* 割込み属性 */
+
+/*
+ *  タイマの設定値のデフォルト値の定義
+ */
+#ifndef MPCORE_GTC_FREQ
+#define MPCORE_GTC_FREQ			1		/* グローバルタイマの駆動周波数 */
+#endif /* MPCORE_GTC_FREQ */
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  グローバルタイマの現在のカウント値（64bit）の読出し
+ */
+Inline uint64_t
+mpcore_gtc_get_count(void)
+{
+	uint32_t	count_l, count_u, prev_count_u;
+
+	count_u = sil_rew_mem(MPCORE_GTC_COUNT_U);
+	do {
+		prev_count_u = count_u;
+		count_l = sil_rew_mem(MPCORE_GTC_COUNT_L);
+		count_u = sil_rew_mem(MPCORE_GTC_COUNT_U);
+	} while (count_u != prev_count_u);
+	return((((uint64_t) count_u) << 32) | ((uint64_t) count_l));
+}
+
+/*
+ *  グローバルタイマのコンパレータ値（64bit）の設定
+ */
+Inline void
+mpcore_gtc_set_cvr(uint64_t cvr)
+{
+
+	uint32_t	cvr_l, cvr_u;
+	uint32_t	reg;
+
+	cvr_l = ((uint32_t) cvr);
+	cvr_u = ((uint32_t)(cvr >> 32));
+
+	/* コンパレータをディスエーブル */
+	reg = sil_rew_mem(MPCORE_GTC_CTRL);
+	sil_wrw_mem(MPCORE_GTC_CTRL, reg & ~(MPCORE_GTC_CTRL_ENACOMP));
+
+	/* コンパレータ値を設定 */
+	sil_wrw_mem(MPCORE_GTC_CVR_L, cvr_l);
+	sil_wrw_mem(MPCORE_GTC_CVR_U, cvr_u);
+
+#ifdef ARM_CA9_GTC_ERRATA
+	/* ARM Cortex-A9 Errata 740657への対策 */
+	sil_wrw_mem(MPCORE_GTC_ISR, MPCORE_GTC_ISR_EVENTFLAG);
+	clear_int(MPCORE_IRQNO_GTC);
+#endif /* ARM_CA9_GTC_ERRATA */
+
+	/* コンパレータと割込みをイネーブル */
+	sil_wrw_mem(MPCORE_GTC_CTRL,
+					reg | (MPCORE_GTC_CTRL_ENACOMP|MPCORE_GTC_CTRL_ENAINT));
+}
+
+/*
+ *  高分解能タイマの起動処理
+ */
+extern void	target_hrt_initialize(intptr_t exinf);
+
+/*
+ *  高分解能タイマの停止処理
+ */
+extern void	target_hrt_terminate(intptr_t exinf);
+
+/*
+ *  高分解能タイマの現在のカウント値の読出し
+ */
+Inline HRTCNT
+target_hrt_get_current(void)
+{
+	/*
+	 *  グローバルタイマのカウント値（64ビット）を読み出し，
+	 *  MPCORE_GTC_FREQで除し，32ビットに切り詰めた値を返す．
+	 */
+	return((HRTCNT)(mpcore_gtc_get_count() / MPCORE_GTC_FREQ));
+}
+
+/*
+ *  高分解能タイマへの割込みタイミングの設定
+ *
+ *  高分解能タイマを，hrtcntで指定した値カウントアップしたら割込みを発
+ *  生させるように設定する．
+ */
+Inline void
+target_hrt_set_event(HRTCNT hrtcnt)
+{
+	/*
+	 *  コンパレータ値を，(現在のカウント値＋hrtcnt×MPCORE_GTC_FREQ)
+	 *  に設定し，コンパレータと割込みをイネーブルする．
+	 */
+	mpcore_gtc_set_cvr(mpcore_gtc_get_count()
+							+ (((uint64_t) hrtcnt) * MPCORE_GTC_FREQ));
+}
+
+/*
+ *  高分解能タイマへの割込みタイミングのクリア
+ */
+#ifdef USE_64BIT_HRTCNT
+
+Inline void
+target_hrt_clear_event(void)
+{
+	sil_wrw_mem(MPCORE_GTC_CTRL,
+					sil_rew_mem(MPCORE_GTC_CTRL) & ~(MPCORE_GTC_CTRL_ENACOMP));
+#ifdef ARM_CA9_GTC_ERRATA
+	/* ARM Cortex-A9 Errata 740657への対策 */
+	sil_wrw_mem(MPCORE_GTC_ISR, MPCORE_GTC_ISR_EVENTFLAG);
+	clear_int(MPCORE_IRQNO_GTC);
+#endif /* ARM_CA9_GTC_ERRATA */
+}
+
+#endif /* USE_64BIT_HRTCNT */
+
+/*
+ *  高分解能タイマ割込みの要求
+ */
+Inline void
+target_hrt_raise_event(void)
+{
+	raise_int(INTNO_TIMER);
+}
+
+/*
+ *  割込みタイミングに指定する最大値
+ */
+#ifndef USE_64BIT_HRTCNT
+
+#if !defined(TCYC_HRTCNT) || (TCYC_HRTCNT > 4002000002U)
+#define HRTCNT_BOUND		4000000002U
+#else
+#define HRTCNT_BOUND		(TCYC_HRTCNT - 2000000U)
+#endif
+
+#endif /* USE_64BIT_HRTCNT */
+
+/*
+ *  高分解能タイマ割込みハンドラ
+ */
+extern void	target_hrt_handler(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* USE_MPCORE_GTC_HRT */
+
+#ifdef USE_MPCORE_WDG_OVRTIMER
+/*
+ *		ウォッチドッグを用いてオーバランタイマを実現
+ */
+#ifdef TOPPERS_SUPPORT_OVRHDR
+
+/*
+ *  オーバランタイマ割込みハンドラ登録のための定数
+ */
+#define INHNO_OVRTIMER		MPCORE_IRQNO_WDG	/* 割込みハンドラ番号 */
+#define INTNO_OVRTIMER		MPCORE_IRQNO_WDG	/* 割込み番号 */
+#define INTPRI_OVRTIMER		TMAX_INTPRI			/* 割込み優先度 */
+#define INTATR_OVRTIMER		TA_NULL				/* 割込み属性 */
+
+/*
+ *  タイマの設定値のデフォルト値の定義
+ */
+#ifndef MPCORE_WDG_FREQ
+#define MPCORE_WDG_FREQ			1		/* ウォッチドッグの駆動周波数 */
+#endif /* MPCORE_WDG_FREQ */
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  オーバランタイマの初期化処理
+ */
+extern void target_ovrtimer_initialize(intptr_t exinf);
+
+/*
+ *  オーバランタイマの終了処理
+ */
+extern void target_ovrtimer_terminate(intptr_t exinf);
+
+/*
+ *  オーバランタイマの動作開始
+ */
+Inline void
+target_ovrtimer_start(PRCTIM ovrtim)
+{
+	/*
+	 *  ウォッチドッグのカウント値を(ovrtim * MPCORE_WDG_FREQ)に設定する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CNT, ovrtim * MPCORE_WDG_FREQ);
+
+	/*
+	 *  ウォッチドッグの動作を開始する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CTRL,
+					sil_rew_mem(MPCORE_WDG_CTRL) | MPCORE_WDG_CTRL_ENABLE);
+}
+
+/*
+ *  オーバランタイマの停止
+ */
+Inline PRCTIM
+target_ovrtimer_stop(void)
+{
+	PRCTIM	ovrtim;
+
+	/*
+	 *  ウォッチドッグの現在値の読出し
+	 */
+	ovrtim = (PRCTIM)(sil_rew_mem(MPCORE_WDG_CNT) / MPCORE_WDG_FREQ);
+
+	/*
+	 *  ウォッチドッグを停止する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CTRL,
+				sil_rew_mem(MPCORE_WDG_CTRL) & ~(MPCORE_WDG_CTRL_ENABLE));
+
+	return(ovrtim);
+}
+
+/*
+ *  オーバランタイマの現在値の読出し
+ */
+Inline PRCTIM
+target_ovrtimer_get_current(void)
+{
+	/*
+	 *  ウォッチドッグのカウント値を読み出し，MPCORE_WDG_FREQで除した
+	 *  値を返す．
+	 */
+	return((PRCTIM)(sil_rew_mem(MPCORE_WDG_CNT) / MPCORE_WDG_FREQ));
+}
+
+/*
+ *  オーバランタイマ割込みハンドラ
+ */
+extern void target_ovrtimer_handler(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* TOPPERS_SUPPORT_OVRHDR */
+#endif /* USE_MPCORE_WDG_OVRTIMER */
+#endif /* TOPPERS_MPCORE_TIMER_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.c	(revision 429)
@@ -0,0 +1,166 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2013-2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		L2キャッシュコントローラ（PL310）の操作ライブラリ
+ */
+
+#include "kernel_impl.h"
+#include "pl310.h"
+
+Inline uint32_t
+get_way_mask(void)
+{
+	uint32_t	aux;
+	
+	aux = sil_rew_mem(PL310_AUX_CTRL);
+	if ((aux & PL310_AUX_CTRL_ASSOCIATIVITY) != 0U) {
+		/* 16ウェイ */
+		return(0x0000ffffU);
+	}
+	else {
+		/* 8ウェイ */
+		return(0x000000ffU);
+	}
+}
+
+Inline void
+pl310_cache_sync(void)
+{
+	sil_wrw_mem(PL310_CACHE_SYNC, 0);
+}
+
+Inline void
+pl310_inv_all(void)
+{
+	uint32_t	way_mask = get_way_mask();
+
+	/* すべてのウェイを無効化する */
+	sil_wrw_mem(PL310_INV_WAY, 0xffff);
+	while ((sil_rew_mem(PL310_INV_WAY) & way_mask) != 0U) ;
+	pl310_cache_sync();
+}
+
+Inline void
+pl310_debug_set(uint32_t val)
+{
+	sil_wrw_mem(PL310_DEBUG_CTRL, val);
+}
+
+/*
+ *  PL310の初期化
+ */
+void
+pl310_initialize(uint32_t aux_val, uint32_t aux_mask)
+{
+	uint32_t	aux;
+	uint32_t	prefetch;
+	uint32_t	prefetch_val = 0U;
+
+	/* L2キャッシュがディスエーブルの場合のみ初期化を行う */
+	if ((sil_rew_mem(PL310_CTRL) & 0x01) == 0U) {
+		/* 共有属性を無視する */
+		aux_val |= PL310_AUX_CTRL_IGNORE_SHARE;
+
+		/* 命令プリフェッチをイネーブル */
+		aux_val |= PL310_AUX_CTRL_INST_PREFETCH;
+		prefetch_val |= PL310_AUX_CTRL_INST_PREFETCH;
+
+		/* データプリフェッチをイネーブル */
+		aux_val |= PL310_AUX_CTRL_DATA_PREFETCH;
+		prefetch_val |= PL310_AUX_CTRL_DATA_PREFETCH;
+
+		/* ダブルラインフィルをイネーブル */
+		prefetch_val |= PL310_PREFETCH_CTRL_DLINEFILL;
+		prefetch_val |= PL310_PREFETCH_CTRL_INCR_DLINEFILL;
+                
+		/* 補助制御レジスタを設定 */
+		aux = sil_rew_mem(PL310_AUX_CTRL);
+		sil_wrw_mem(PL310_AUX_CTRL, ((aux & aux_mask) | aux_val));
+
+		/* プリフェッチ制御レジスタを設定 */
+		prefetch = sil_rew_mem(PL310_PREFETCH_CTRL);
+		sil_wrw_mem(PL310_PREFETCH_CTRL, (prefetch | prefetch_val));
+
+		/* L2キャッシュの全体の無効化 */
+		pl310_inv_all();
+        
+		/* クロックゲーティングとスタンバイモードをイネーブル */
+		sil_wrw_mem(PL310_POWER_CTRL, 0x03);
+        
+		/* L2キャッシュのイネーブル */
+		sil_wrw_mem(PL310_CTRL, 0x01);
+	}    
+}
+
+/*
+ *  L2キャッシュのディスエーブル
+ */
+void
+pl310_disable(void)
+{
+	pl310_clean_and_invalidate_all();
+	sil_wrw_mem(PL310_CTRL, 0x00);
+}
+
+/*
+ *  L2キャッシュ全体の無効化（書き戻さない）
+ */
+void
+pl310_invalidate_all(void)
+{
+	pl310_debug_set(0x03);
+	pl310_inv_all();
+	pl310_debug_set(0x00);
+}
+
+/*
+ *  L2キャッシュ全体のクリーンと無効化
+ */
+void
+pl310_clean_and_invalidate_all(void)
+{
+	uint32_t	way_mask = get_way_mask();
+
+	pl310_debug_set(0x03);
+	sil_wrw_mem(PL310_CLEAN_INV_WAY, way_mask);
+	while ((sil_rew_mem(PL310_CLEAN_INV_WAY) & way_mask) != 0U) ;
+	pl310_cache_sync();
+	pl310_debug_set(0x00);
+}
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/pl310.h	(revision 429)
@@ -0,0 +1,131 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2013-2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		L2キャッシュコントローラ（PL310）に関する定義
+ */
+
+#ifndef TOPPERS_PL310_H
+#define TOPPERS_PL310_H
+
+/*
+ *  型キャストを行うマクロの定義
+ */
+#ifndef CAST
+#define CAST(type, val)		((type)(val))
+#endif /* CAST */
+
+/*
+ *  PL310のレジスタの番地の定義
+ */
+#define PL310_CACHE_ID			CAST(uint32_t *, PL310_BASE + 0x000)
+#define PL310_CACHE_TYPE		CAST(uint32_t *, PL310_BASE + 0x004)
+#define PL310_CTRL				CAST(uint32_t *, PL310_BASE + 0x100)
+#define PL310_AUX_CTRL			CAST(uint32_t *, PL310_BASE + 0x104)
+#define PL310_TAG_RAM_CTRL		CAST(uint32_t *, PL310_BASE + 0x108)
+#define PL310_DATA_RAM_CTRL		CAST(uint32_t *, PL310_BASE + 0x10c)
+#define PL310_EVENT_CNT_CTRL	CAST(uint32_t *, PL310_BASE + 0x200)
+#define PL310_EVENT_CNT1_CFG	CAST(uint32_t *, PL310_BASE + 0x204)
+#define PL310_EVENT_CNT0_CFG	CAST(uint32_t *, PL310_BASE + 0x208)
+#define PL310_EVENT_CNT1		CAST(uint32_t *, PL310_BASE + 0x20c)
+#define PL310_EVENT_CNT0		CAST(uint32_t *, PL310_BASE + 0x210)
+#define PL310_INT_MASK			CAST(uint32_t *, PL310_BASE + 0x214)
+#define PL310_INT_MASK_STAT		CAST(uint32_t *, PL310_BASE + 0x218)
+#define PL310_INT_RAW_STAT		CAST(uint32_t *, PL310_BASE + 0x21c)
+#define PL310_INT_CLEAR			CAST(uint32_t *, PL310_BASE + 0x220)
+#define PL310_CACHE_SYNC		CAST(uint32_t *, PL310_BASE + 0x730)
+#define PL310_INV_PA			CAST(uint32_t *, PL310_BASE + 0x770)
+#define PL310_INV_WAY			CAST(uint32_t *, PL310_BASE + 0x77c)
+#define PL310_CLEAN_PA			CAST(uint32_t *, PL310_BASE + 0x7b0)
+#define PL310_CLEAN_IDX			CAST(uint32_t *, PL310_BASE + 0x7b8)
+#define PL310_CLEAN_WAY			CAST(uint32_t *, PL310_BASE + 0x7bc)
+#define PL310_CLEAN_INV_PA		CAST(uint32_t *, PL310_BASE + 0x7f0)
+#define PL310_CLEAN_INV_IDX		CAST(uint32_t *, PL310_BASE + 0x7f8)
+#define PL310_CLEAN_INV_WAY		CAST(uint32_t *, PL310_BASE + 0x7Fc)
+#define PL310_D_LOCKDOWN0		CAST(uint32_t *, PL310_BASE + 0x900)
+#define PL310_I_LOCKDOWN0		CAST(uint32_t *, PL310_BASE + 0x904)
+#define PL310_DEBUG_CTRL		CAST(uint32_t *, PL310_BASE + 0xf40)
+#define PL310_PREFETCH_CTRL		CAST(uint32_t *, PL310_BASE + 0xf60)
+#define PL310_POWER_CTRL		CAST(uint32_t *, PL310_BASE + 0xf80)
+
+/*
+ *  キャッシュ補助制御レジスタ（PL310_AUX_CTRL）の設定値
+ */
+#define PL310_AUX_CTRL_ASSOCIATIVITY		0x00010000
+#define PL310_AUX_CTRL_WAY_SIZE_SHIFT		17
+#define PL310_AUX_CTRL_WAY_SIZE_MASK		0x000e0000
+#define PL310_AUX_CTRL_IGNORE_SHARE			0x00400000
+#define PL310_AUX_CTRL_NS_LOCKDOWN			0x04000000
+#define PL310_AUX_CTRL_NS_INT_CTRL			0x08000000
+#define PL310_AUX_CTRL_DATA_PREFETCH		0x10000000
+#define PL310_AUX_CTRL_INST_PREFETCH		0x20000000
+#define PL310_AUX_CTRL_EARLY_BRESP			0x40000000
+
+/*
+ *  プリフェッチ制御レジスタ（PL310_PREFETCH_CTRL）の設定値
+ */
+#define PL310_PREFETCH_CTRL_INCR_DLINEFILL	0x00800000
+#define PL310_PREFETCH_CTRL_DATA_PREFETCH	0x10000000
+#define PL310_PREFETCH_CTRL_INST_PREFETCH	0x20000000
+#define PL310_PREFETCH_CTRL_DLINEFILL		0x40000000
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  L2キャッシュの初期化とイネーブル
+ */
+extern void pl310_initialize(uint32_t aux_val, uint32_t aux_mask);
+
+/*
+ *  L2キャッシュのディスエーブル
+ */
+extern void pl310_disable(void);
+
+/*
+ *  L2キャッシュ全体の無効化（書き戻さない）
+ */
+extern void pl310_invalidate_all(void);
+
+/*
+ *  L2キャッシュ全体のクリーンと無効化
+ */
+extern void pl310_clean_and_invalidate_all(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* TOPPERS_PL310_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.c	(revision 429)
@@ -1,8 +1,7 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
- * 
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -95,33 +94,41 @@
 	CELLCB	*p_cellcb = GET_CELLCB(idx);
 
-	/*
-	 *  UARTをディスエーブル
-	 */
-	sil_wrw_mem(UART_CR(ATTR_baseAddress), 0U);
-
-	/*
-	 *  エラーフラグをクリア
-	 */
-	sil_wrw_mem(UART_ECR(ATTR_baseAddress), 0U);
-
-	/*
-	 *  FIFOを空にする
-	 */
-	while (uart_pl011_getready(p_cellcb)) {
-		(void) uart_pl011_getchar(p_cellcb);
-	}
-
-	/*
-	 *  ボーレートと通信規格を設定
-	 */
-	sil_wrw_mem(UART_IBRD(ATTR_baseAddress), ATTR_ibrd);
-	sil_wrw_mem(UART_FBRD(ATTR_baseAddress), ATTR_fbrd);
-	sil_wrw_mem(UART_LCR_H(ATTR_baseAddress), ATTR_lcr_h);
-		
-	/*
-	 *  UARTをイネーブル
-	 */
-	sil_wrw_mem(UART_CR(ATTR_baseAddress),
+	if (!VAR_opened) {
+		/*
+		 *  既にオープンしている場合は、二重にオープンしない．
+		 */
+
+		/*
+		 *  UARTをディスエーブル
+		 */
+		sil_wrw_mem(UART_CR(ATTR_baseAddress), 0U);
+
+		/*
+		 *  エラーフラグをクリア
+		 */
+		sil_wrw_mem(UART_ECR(ATTR_baseAddress), 0U);
+
+		/*
+		 *  FIFOを空にする
+		 */
+		while (uart_pl011_getready(p_cellcb)) {
+			(void) uart_pl011_getchar(p_cellcb);
+		}
+
+		/*
+		 *  ボーレートと通信規格を設定
+		 */
+		sil_wrw_mem(UART_IBRD(ATTR_baseAddress), ATTR_ibrd);
+		sil_wrw_mem(UART_FBRD(ATTR_baseAddress), ATTR_fbrd);
+		sil_wrw_mem(UART_LCR_H(ATTR_baseAddress), ATTR_lcr_h);
+
+		/*
+		 *  UARTをイネーブル
+		 */
+		sil_wrw_mem(UART_CR(ATTR_baseAddress),
 						UART_CR_UARTEN|UART_CR_TXE|UART_CR_RXE);
+
+		VAR_opened = true;
+	}
 }
 
@@ -134,8 +141,12 @@
 	CELLCB	*p_cellcb = GET_CELLCB(idx);
 
-	/*
-	 *  UARTをディスエーブル
-	 */
-	sil_wrw_mem(UART_CR(ATTR_baseAddress), 0U);
+	if (VAR_opened) {
+		/*
+		 *  UARTをディスエーブル
+		 */
+		sil_wrw_mem(UART_CR(ATTR_baseAddress), 0U);
+
+		VAR_opened = false;
+	}
 }
 
@@ -232,2 +243,11 @@
 	}
 }
+
+/*
+ *  SIOドライバの終了処理
+ */
+void
+eTerminate_main(CELLIDX idx)
+{
+	eSIOPort_close(idx);
+}
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/tUartPL011.cdl	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015 by Ushio Laboratory
  *              Graduate School of Engineering Science, Osaka Univ., JAPAN
- *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -58,4 +57,5 @@
 
 	entry	siHandlerBody	eiISR;
+	entry	sRoutineBody	eTerminate;
 
 	attr {
@@ -65,3 +65,6 @@
 		uint8_t		lcr_h;			/* ライン制御レジスタの設定値 */
 	};
+	var {
+		bool_t		opened = false;	/* オープン済み */
+	};
 };
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/uart_pl011.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/uart_pl011.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/uart_pl011.h	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/Makefile.chip
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/Makefile.chip	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/Makefile.chip	(revision 429)
@@ -2,5 +2,5 @@
 #		Makefile のチップ依存部（RZ/A1用）
 #
-#  $Id$
+#  $Id: Makefile.chip 720 2016-04-01 22:16:17Z ertl-hiro $
 # 
 
@@ -22,7 +22,12 @@
 #
 KERNEL_DIRS := $(KERNEL_DIRS) $(CHIPDIR)
+KERNEL_COBJS := $(KERNEL_COBJS) chip_kernel_impl.o mpcore_kernel_impl.o \
+									gic_kernel_impl.o pl310.o chip_timer.o
 KERNEL_ASMOBJS := $(KERNEL_ASMOBJS) gic_support.o
-KERNEL_COBJS := $(KERNEL_COBJS) chip_kernel_impl.o gic_kernel_impl.o \
-															chip_timer.o
+
+#
+#  システムサービスに関する定義
+#
+SYSSVC_DIRS := $(SYSSVC_DIRS) $(CHIPDIR)
 
 #
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.h	(revision 429)
@@ -3,8 +3,8 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems/
  *      Advanced Standard Profile Kernel
- *
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ * 
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
+ * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -29,5 +29,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- *
+ * 
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -35,5 +35,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- *
+ * 
  *  $Id$
  */
@@ -42,7 +42,7 @@
  *		kernel.hのターゲット依存部（RZ/A1用）
  *
- *  このヘッダファイルは，kernel.hからインクルードされる．他のファイル
- *  から直接インクルードすることはない．このファイルをインクルードする
- *  前に，t_stddef.hがインクルードされるので，それに依存してもよい．
+ *  このヘッダファイルは，target_kernel.h（または，そこからインクルー
+ *  ドされるファイル）のみからインクルードされる．他のファイルから直接
+ *  インクルードしてはならない．
  */
 
@@ -66,32 +66,13 @@
  *  サポートできる機能の定義
  *
- *  ena_int／dis_intとオーバランハンドラをサポートすることができる．
+ *  ena_int／dis_int／clr_int／ras_int／prb_intとオーバランハンドラを
+ *  サポートすることができる．
  */
 #define TOPPERS_TARGET_SUPPORT_ENA_INT		/* ena_int */
 #define TOPPERS_TARGET_SUPPORT_DIS_INT		/* dis_int */
+#define TOPPERS_TARGET_SUPPORT_CLR_INT		/* clr_int */
+#define TOPPERS_TARGET_SUPPORT_RAS_INT		/* ras_int */
+#define TOPPERS_TARGET_SUPPORT_PRB_INT		/* prb_int */
 #define TOPPERS_TARGET_SUPPORT_OVRHDR
-
-/*
- *  高分解能タイマのタイマ周期
- *
- *  2^32 / 33.33…を丸めた値とする．
- */
-#define TCYC_HRTCNT		128849019U
-
-/*
- *  高分解能タイマのカウント値の進み幅
- */
-#define TSTEP_HRTCNT	1U
-
-/*
- *  オーバランハンドラの残りプロセッサ時間に指定できる最大値
- *
- *  この値をOSタイマへの設定値に変換してタイマに設定した後，タイマの現
- *  在値を読み出してμ秒単位に変換できる値としている．タイマの現在値を
- *  μ秒単位に変換する時に34を加えるため，以下の条件を満たす最大の値と
- *  する．
- *		(TMAX_OVRTIM * 33 + TMAX_OVRTIM / 3 + 1) + 34 < 2^32
- */
-#define TMAX_OVRTIM		128849017U
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel.trb	(revision 429)
@@ -27,6 +27,6 @@
 #  割込み要求ライン属性に関するターゲット依存のエラーチェック
 #
-$cfgData[:CFG_INT].each do |key, params|
-  if $INTNO_IRQ0 <= key && key <= $INTNO_IRQ7
+$cfgData[:CFG_INT].each do |_, params|
+  if $INTNO_IRQ0 <= params[:intno] && params[:intno] <= $INTNO_IRQ7
     # IRQ割込みの場合
     #（TA_EDGEがセットされている場合）
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.c	(revision 429)
@@ -3,10 +3,10 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems/
  *      Advanced Standard Profile Kernel
- *
+ * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
+ * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -31,5 +31,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- *
+ * 
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -37,5 +37,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- *
+ * 
  *  $Id$
  */
@@ -46,5 +46,7 @@
 
 #include "kernel_impl.h"
+#include <sil.h>
 #include "interrupt.h"
+#include "pl310.h"
 
 /*
@@ -55,67 +57,24 @@
 {
 	/*
-	 *  キャッシュをディスエーブル
+	 *  MPCore依存の初期化
 	 */
-	arm_disable_cache();
+	mpcore_initialize();
 
 	/*
-	 *  コア依存の初期化
+	 *  L2キャッシュコントローラ（PL310）の初期化
 	 */
-	core_initialize();
-
-	/*
-	 *  キャッシュをイネーブル
-	 */
-	arm_enable_cache();
-
-	/*
-	 *  GICのディストリビュータの初期化
-	 */
-	gicd_initialize();
-
-	/*
-	 *  GICのCPUインタフェースの初期化
-	 */
-	gicc_initialize();
-
-	/*
-	 *  分岐予測の無効化とイネーブル
-	 */
-	arm_invalidate_bp();
-	arm_enable_bp();
+	pl310_initialize(0x0U, ~0x0U);
 }
 
 /*
- *  チップ依存部の終了処理
+ *  チップ依存の終了処理
  */
 void
 chip_terminate(void)
 {
-	extern void    software_term_hook(void);
-	void (*volatile fp)(void) = software_term_hook;
-
 	/*
-	 *  software_term_hookへのポインタを，一旦volatile指定のあるfpに代
-	 *  入してから使うのは，0との比較が最適化で削除されないようにするた
-	 *  めである．
+	 *  MPCore依存の終了処理
 	 */
-	if (fp != 0) {
-		(*fp)();
-	}
-
-	/*
-	 *  GICのCPUインタフェースの終了処理
-	 */
-	gicc_terminate();
-
-	/*
-	 *  GICのディストリビュータの終了処理
-	 */
-	gicd_terminate();
-
-	/*
-	 *  コア依存の終了処理
-	 */
-	core_terminate();
+	mpcore_terminate();
 }
 
@@ -177,5 +136,5 @@
 	 */
 	gicd_set_priority(intno, INT_IPM(intpri));
-	gicd_set_target(intno, 1U << arm_prc_index());
+	gicd_set_target(intno, 1U << get_my_prcidx());
 
 	/*
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_kernel_impl.h	(revision 429)
@@ -3,10 +3,10 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems/
  *      Advanced Standard Profile Kernel
- *
+ * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
+ * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -31,5 +31,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- *
+ * 
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -37,5 +37,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- *
+ * 
  *  $Id$
  */
@@ -58,8 +58,9 @@
 
 /*
- *  MMUの使用に関する設定
+ *  デフォルトの非タスクコンテキスト用のスタック領域の定義
  */
-#define USE_ARM_MMU
-#define USE_ARM_SSECTION
+#ifndef DEFAULT_ISTKSZ
+#define DEFAULT_ISTKSZ  0x2000U			/* 8KB */
+#endif /* DEFAULT_ISTKSZ */
 
 /*
@@ -70,14 +71,17 @@
 
 /*
- *  GIC依存部の割込み管理機能の初期化は使用しない．
+ *  GIC 390 Errataへの対策を実施
+ */
+#define GIC_PL390_ERRATA
+
+/*
+ *  GIC依存部の割込み管理機能の初期化は使用しない
  */
 #define OMIT_GIC_INITIALIZE_INTERRUPT
 
 /*
- *  GICに関する定義，コアで共通な定義
- *
- *  core_kernel_impl.hは，gic_kernel_impl.hからインクルードされる．
+ *  MPCoreで共通な定義
  */
-#include "gic_kernel_impl.h"
+#include "mpcore_kernel_impl.h"
 
 #ifndef TOPPERS_MACRO_ONLY
